'*** File Details *****************************************************************
'    File        : Form1.vb
'    Requires    : None
'    Type        : VB.NET Class
'    Description : Test form for Hercules DJ Console
'
' HERC.DLL Copyright  2005 Greg Ellis. All rights reserved.
' VB.NET Interface Copyright  2006 ActiveASP Software. All rights reserved.
'
' Send improvements, updates, questions to biggun@wi.rr.com
'
'--- Change Log   -----------------------------------------------------------------
'    4/5/2006 by Rick (Big_Gun) - Initial Creation
'**********************************************************************************

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents CheckBox1 As System.Windows.Forms.CheckBox
    Friend WithEvents PictureBox1 As System.Windows.Forms.PictureBox
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents CheckBox2 As System.Windows.Forms.CheckBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(Form1))
        Me.CheckBox1 = New System.Windows.Forms.CheckBox
        Me.PictureBox1 = New System.Windows.Forms.PictureBox
        Me.Label1 = New System.Windows.Forms.Label
        Me.CheckBox2 = New System.Windows.Forms.CheckBox
        Me.SuspendLayout()
        '
        'CheckBox1
        '
        Me.CheckBox1.Location = New System.Drawing.Point(236, 76)
        Me.CheckBox1.Name = "CheckBox1"
        Me.CheckBox1.Size = New System.Drawing.Size(228, 24)
        Me.CheckBox1.TabIndex = 0
        Me.CheckBox1.Text = "Toggle Left Play/Pause LED"
        '
        'PictureBox1
        '
        Me.PictureBox1.Image = CType(resources.GetObject("PictureBox1.Image"), System.Drawing.Image)
        Me.PictureBox1.Location = New System.Drawing.Point(0, 0)
        Me.PictureBox1.Name = "PictureBox1"
        Me.PictureBox1.Size = New System.Drawing.Size(220, 220)
        Me.PictureBox1.SizeMode = System.Windows.Forms.PictureBoxSizeMode.AutoSize
        Me.PictureBox1.TabIndex = 1
        Me.PictureBox1.TabStop = False
        '
        'Label1
        '
        Me.Label1.Location = New System.Drawing.Point(232, 8)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(236, 64)
        Me.Label1.TabIndex = 2
        Me.Label1.Text = "Version"
        '
        'CheckBox2
        '
        Me.CheckBox2.Location = New System.Drawing.Point(236, 112)
        Me.CheckBox2.Name = "CheckBox2"
        Me.CheckBox2.Size = New System.Drawing.Size(228, 24)
        Me.CheckBox2.TabIndex = 3
        Me.CheckBox2.Text = "Toggle Right Cue LED"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(6, 15)
        Me.ClientSize = New System.Drawing.Size(480, 226)
        Me.Controls.Add(Me.CheckBox2)
        Me.Controls.Add(Me.Label1)
        Me.Controls.Add(Me.PictureBox1)
        Me.Controls.Add(Me.CheckBox1)
        Me.Font = New System.Drawing.Font("Tahoma", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.MaximizeBox = False
        Me.Name = "Form1"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "Hercules DJ Console VB.NET Test"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private didOpenHercules As Boolean = False

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim vers As Integer = Hercules.DJConsole.HercNet.HERC_GetVersion
        Label1.Text = Me.Text + vbCrLf + "Version " + vers.ToString

        Dim t As Boolean = Hercules.DJConsole.HercNet.HERC_Init(Hercules.DJConsole.HercNet.HercConsoleTypes.HERC_CONSOLE_ALL, Me.Handle)

        If t = False Then
            MsgBox(Hercules.DJConsole.HercNet.HERC_ErrorGetCode().ToString)
            Application.Exit()
        Else
            didOpenHercules = True
            ' This callback crashes, I don't know why...
            ' It receives stuff from the console, but then it crashes.
            Try
                'Hercules.DJConsole.HercNet.HERC_EventCallbackSet(AddressOf HercEventCallbackHandlerA, AddressOf HercEventCallbackHandlerB, 69)
            Catch ex As Exception

            End Try
        End If
    End Sub

    Private Sub Form1_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        If didOpenHercules Then
            Hercules.DJConsole.HercNet.HERC_SetLED(Hercules.DJConsole.HercNet.HercDeck.HERC_DECK_A, Hercules.DJConsole.HercNet.HercLedType.HERC_LED_PLAY, False)
            Hercules.DJConsole.HercNet.HERC_SetLED(Hercules.DJConsole.HercNet.HercDeck.HERC_DECK_B, Hercules.DJConsole.HercNet.HercLedType.HERC_LED_CUE, False)
            Hercules.DJConsole.HercNet.HERC_Free()
        End If
    End Sub

    Public Sub HercEventCallbackHandlerA(ByVal dwAction As Hercules.DJConsole.HercNet.HercAction, ByVal dwValue As Integer, ByVal userInstance As Integer)
        If userInstance <> 69 Then Exit Sub

        MsgBox("Deck A" + vbCrLf + dwAction.ToString + vbCrLf + "Action: " + dwValue.ToString + vbCrLf + "User: " + userInstance.ToString)
    End Sub

    Public Sub HercEventCallbackHandlerB(ByVal dwAction As Hercules.DJConsole.HercNet.HercAction, ByVal dwValue As Integer, ByVal userInstance As Integer)
        If userInstance <> 69 Then Exit Sub

        MsgBox("Deck B" + vbCrLf + dwAction.ToString + vbCrLf + "Action: " + dwValue.ToString + vbCrLf + "User: " + userInstance.ToString)
    End Sub

    Private Sub CheckBox1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox1.CheckedChanged
        Hercules.DJConsole.HercNet.HERC_SetLED(Hercules.DJConsole.HercNet.HercDeck.HERC_DECK_A, Hercules.DJConsole.HercNet.HercLedType.HERC_LED_PLAY, CheckBox1.Checked)
    End Sub

    Private Sub CheckBox2_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox2.CheckedChanged
        Hercules.DJConsole.HercNet.HERC_SetLED(Hercules.DJConsole.HercNet.HercDeck.HERC_DECK_B, Hercules.DJConsole.HercNet.HercLedType.HERC_LED_CUE, CheckBox1.Checked)
    End Sub
End Class
