// HERC.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "HERC.h"

#include <mmsystem.h>

//USB HID STUFF

#include <wtypes.h>
#include <initguid.h>

#define MAX_LOADSTRING 256

extern "C" {

// This file is in the Windows DDK available from Microsoft.
#include "hidsdi.h"

#include <setupapi.h>
#include <dbt.h>
}

//Application global variables 
	char								Buf[64];
	BYTE								ReadBuf[64];
	DWORD								ActualBytesRead;
	DWORD								BytesRead;
	HIDP_CAPS							Capabilities;
	DWORD								cbBytesRead;
	PSP_DEVICE_INTERFACE_DETAIL_DATA	detailData;
	HANDLE								DeviceHandle;
	DWORD								dwError;
	char								FeatureReport[256];
	HANDLE								hEventObject;
	HANDLE								hDevInfo;
	GUID								HidGuid;
	OVERLAPPED							HIDOverlapped;
	char								InputReport[256];
	ULONG								Length;
	LPOVERLAPPED						lpOverLap;
	bool								MyDeviceDetected = FALSE; 
	CString								MyDevicePathName;
	DWORD								NumberOfBytesRead;
	char								OutputReport[256];
	HANDLE								ReadHandle;
	DWORD								ReportType;
	ULONG								Required;
	CString								ValueToDisplay;
	HANDLE								WriteHandle;


//regular herc
//int VendorID = 0x06F8;
//int ProductID = 0xB000;

//new herc mk2
//int VendorID = 0x06F8;
//int ProductID = 0xB100;

//new herc control mp3
//int VendorID = 0x06F8;
//int ProductID = 0xD001;

	int VendorID = 0x06F8;
	int aProductID[3] = {0xB000, 0xB100, 0xD001}; //HerculesDJConsole, HerculesDJConsoleMK2, HerculesControlMP3
	int nConsoleType = 0;

int nLEDString1, nLEDString2, nLEDString3 = 0;

BOOL bLEDPlayOn[2] = {0,0};
BOOL bLEDCueOn[2] = {0,0};
BOOL bLEDAutoBeatOn[2] = {0,0};
BOOL bLEDMonitorOn[2] = {0,0};
BOOL bLEDMasterTempoOn[2] = {0,0};
BOOL bLEDLoopFXOn[2] = {0,0};
BOOL bLEDCueFXOn[2] = {0,0};
BOOL bLEDFXOn[2] = {0,0};

BOOL DeviceNameMatch(LPARAM lParam);
bool FindTheHID(int nProductID);
void CloseHandles();
void GetDeviceCapabilities();
void PrepareForOverlappedTransfer();
void ReadAndWriteToDevice();
void WriteHercules(CString cszLED, BOOL bOn, DWORD dwLED, DWORD dwDeckID);
void ReadHercules();
void RegisterForDeviceNotifications();

void RegisterForDeviceNotifications()
{

	DEV_BROADCAST_DEVICEINTERFACE DevBroadcastDeviceInterface;
	HDEVNOTIFY DeviceNotificationHandle;

	DevBroadcastDeviceInterface.dbcc_size = sizeof(DevBroadcastDeviceInterface);
	DevBroadcastDeviceInterface.dbcc_devicetype = DBT_DEVTYP_DEVICEINTERFACE;
	DevBroadcastDeviceInterface.dbcc_classguid = HidGuid;

	DeviceNotificationHandle =
		RegisterDeviceNotification(hidwnd, &DevBroadcastDeviceInterface, DEVICE_NOTIFY_WINDOW_HANDLE);

}

UINT WorkerThread(LPVOID pParam)
{
	while(!bTerminated)
	{
		ReadHercules();
		Sleep(5);
	}
	
	return 0;
}

void ReadHercules()
{
	CString	ByteToDisplay = "";
	
	DWORD	Result;
	
	
	if (ReadHandle != INVALID_HANDLE_VALUE)
	{
		Result = ReadFile 
			(ReadHandle, 
			ReadBuf, 
			Capabilities.InputReportByteLength, 
			&NumberOfBytesRead,
			(LPOVERLAPPED) &HIDOverlapped); 
	}
	
	
	
	Result = WaitForSingleObject 
		(hEventObject, 
		6000);
	
	
	
	switch (Result)
	{
	case WAIT_OBJECT_0:
		{
			
			
			int leftbass, leftmid, lefttreble;
			int rightbass, rightmid, righttreble;
			int crossfade, leftpitch, rightpitch, leftvolume, rightvolume,leftjogwheel,rightjogwheel;

			CString cszCode;
			int code;
			if(m_dwConsoleType == HERC_CONSOLE_MK2)
			{

				
				cszCode.Format("%02x%02x%02x%02x", ReadBuf[1], ReadBuf[2],ReadBuf[3],ReadBuf[4]);
						
				_stscanf(cszCode.Mid(0,8), _T("%08x"), &code);


				//stuff is different for mk2
				//so we have to switch registers around

				lefttreble = ReadBuf[11];
				leftmid = ReadBuf[10];
				leftbass = ReadBuf[9];

				righttreble = ReadBuf[8];
				rightmid = ReadBuf[7];
				rightbass = ReadBuf[6];

				crossfade = ReadBuf[12];
				leftpitch = ReadBuf[13];
				rightpitch = ReadBuf[14];
				leftvolume = ReadBuf[15];
				rightvolume = ReadBuf[16];
				leftjogwheel = ReadBuf[17];
				rightjogwheel = ReadBuf[18];

			}
			else
			{
				
			cszCode.Format("%02x%02x%02x%02x", ReadBuf[1], ReadBuf[2],ReadBuf[3],ReadBuf[4]-128);
			
			_stscanf(cszCode.Mid(0,8), _T("%08x"), &code);


				leftbass = ReadBuf[8];
				leftmid  = ReadBuf[9];
				lefttreble = ReadBuf[10];
				
				rightbass = ReadBuf[5];
				rightmid  = ReadBuf[6];
				righttreble = ReadBuf[7];
				
				crossfade = ReadBuf[11];
				leftpitch = ReadBuf[12];
				rightpitch = ReadBuf[13];
				leftvolume = ReadBuf[14];
				rightvolume = ReadBuf[15];
				leftjogwheel = ReadBuf[16];
				rightjogwheel = ReadBuf[17];
			}



		



			//Handle Left Side Buttons

			if(code & LeftPlay)
			{
				if(m_bPlayDownDeckA == FALSE)
				{
					m_bPlayDownDeckA = TRUE;
					m_proca(HERC_PLAY, 127, m_dwUser);
				}
				
			}
			else
			{
				if(m_bPlayDownDeckA == TRUE)
				{
					m_bPlayDownDeckA = FALSE;
					m_proca(HERC_PLAY, 0, m_dwUser);
				}
			}
			
			if(code & LeftCue)
			{
				if(m_bCueDownDeckA == FALSE)
				{
					m_bCueDownDeckA = TRUE;
					m_proca(HERC_CUE, 127, m_dwUser);
				}
				
			}
			else
			{
				if(m_bCueDownDeckA == TRUE)
				{
					m_bCueDownDeckA = FALSE;
					m_proca(HERC_CUE, 0, m_dwUser);
				}
			}

			if(code & LeftTrackPrev)
			{
				if(m_bTrackPrevDownDeckA == FALSE)
				{
					m_bTrackPrevDownDeckA = TRUE;
					m_proca(HERC_TRACKPREV, 127, m_dwUser);
				}				
			}
			else
			{
				if(m_bTrackPrevDownDeckA == TRUE)
				{
					m_bTrackPrevDownDeckA = FALSE;
					m_proca(HERC_TRACKPREV, 0, m_dwUser);
				}
			}

			if(code & LeftTrackNext)
			{
				if(m_bTrackNextDownDeckA == FALSE)
				{
					m_bTrackNextDownDeckA = TRUE;
					m_proca(HERC_TRACKNEXT, 127, m_dwUser);
				}
			}
			else
			{
				if(m_bTrackNextDownDeckA == TRUE)
				{
					m_bTrackNextDownDeckA = FALSE;
					m_proca(HERC_TRACKNEXT, 0, m_dwUser);
				}
			}

			if(code & LeftPitchBendPlus)
			{
				if(m_bPitchBendUpDownDeckA == FALSE)
				{
					m_bPitchBendUpDownDeckA = TRUE;
					m_proca(HERC_PITCHBEND_UP, 127, m_dwUser);
				}
			}
			else
			{
				if(m_bPitchBendUpDownDeckA == TRUE)
				{
					m_bPitchBendUpDownDeckA = FALSE;
					m_proca(HERC_PITCHBEND_UP, 0, m_dwUser);
				}
			}

			if(code & LeftPitchBendMinus)
			{
				if(m_bPitchBendDownDownDeckA == FALSE)
				{
					m_bPitchBendDownDownDeckA = TRUE;
					m_proca(HERC_PITCHBEND_DOWN, 127, m_dwUser);
				}
			}
			else
			{
				if(m_bPitchBendDownDownDeckA == TRUE)
				{
					m_bPitchBendDownDownDeckA = FALSE;
					m_proca(HERC_PITCHBEND_DOWN, 0, m_dwUser);
				}
			}

			if(code & LeftPreview)
			{
				if(m_bPreviewDownDeckA == FALSE)
				{
					m_bPreviewDownDeckA = TRUE;
					m_proca(HERC_PREVIEW, 127, m_dwUser);
				}
			}
			else
			{
				if(m_bPreviewDownDeckA == TRUE)
				{
					m_bPreviewDownDeckA = FALSE;
					m_proca(HERC_PREVIEW, 0, m_dwUser);
				}
			}

			if(code & LeftOne)
			{
				if(m_bOneDownDeckA == FALSE)
				{
					m_bOneDownDeckA = TRUE;
					m_proca(HERC_ONE, 127, m_dwUser);
				}
			}
			else
			{
				if(m_bOneDownDeckA == TRUE)
				{
					m_bOneDownDeckA = FALSE;
					m_proca(HERC_ONE, 0, m_dwUser);
				}
			}

			if(code & LeftTwo)
			{
				if(m_bTwoDownDeckA == FALSE)
				{
					m_bTwoDownDeckA = TRUE;
					m_proca(HERC_TWO, 127, m_dwUser);
				}
			}
			else
			{
				if(m_bTwoDownDeckA == TRUE)
				{
					m_bTwoDownDeckA = FALSE;
					m_proca(HERC_TWO, 0, m_dwUser);
				}
			}

			if(code & LeftThree)
			{
				if(m_bThreeDownDeckA == FALSE)
				{
					m_bThreeDownDeckA = TRUE;
					m_proca(HERC_THREE, 127, m_dwUser);
				}
			}
			else
			{
				if(m_bThreeDownDeckA == TRUE)
				{
					m_bThreeDownDeckA = FALSE;
					m_proca(HERC_THREE, 0, m_dwUser);
				}
			}

			if(code & LeftSelectFX)
			{
				if(m_bSelectFXDownDeckA == FALSE)
				{
					m_bSelectFXDownDeckA = TRUE;
					m_proca(HERC_SELECTFX, 127, m_dwUser);
				}
			}
			else
			{
				if(m_bSelectFXDownDeckA == TRUE)
				{
					m_bSelectFXDownDeckA = FALSE;
					m_proca(HERC_SELECTFX, 0, m_dwUser);
				}
			}

			if(code & LeftMasterTempo)
			{
				if(m_bMasterTempoDownDeckA == FALSE)
				{
					m_bMasterTempoDownDeckA = TRUE;
					m_proca(HERC_MASTERTEMPO, 127, m_dwUser);
				}
			}
			else
			{
				if(m_bMasterTempoDownDeckA == TRUE)
				{
					m_bMasterTempoDownDeckA = FALSE;
					m_proca(HERC_MASTERTEMPO, 0, m_dwUser);
				}
			}

			if(code & LeftAutoBeat)
			{
				if(m_bAutoBeatDownDeckA == FALSE)
				{
					m_bAutoBeatDownDeckA = TRUE;
					m_proca(HERC_AUTOBEAT, 127, m_dwUser);
				}
			}
			else
			{
				if(m_bAutoBeatDownDeckA == TRUE)
				{
					m_bAutoBeatDownDeckA = FALSE;
					m_proca(HERC_AUTOBEAT, 0, m_dwUser);
				}
			}

			if(code & LeftMouseButton)
			{
				if(m_bMouseButtonDownDeckA == FALSE)
				{
					m_bMouseButtonDownDeckA = TRUE;
					m_proca(HERC_MOUSEBUTTON, 127, m_dwUser);
				}
			}
			else
			{
				if(m_bMouseButtonDownDeckA == TRUE)
				{
					m_bMouseButtonDownDeckA = FALSE;
					m_proca(HERC_MOUSEBUTTON, 0, m_dwUser);
				}
			}




			//Handle Right Side Buttons

			if(code & RightPlay)
			{
				if(m_bPlayDownDeckB == FALSE)
				{
					m_bPlayDownDeckB = TRUE;
					m_procb(HERC_PLAY, 127, m_dwUser);
				}
				
			}
			else
			{
				if(m_bPlayDownDeckB == TRUE)
				{
					m_bPlayDownDeckB = FALSE;
					m_procb(HERC_PLAY, 0, m_dwUser);
				}
			}
			
			if(code & RightCue)
			{
				if(m_bCueDownDeckB == FALSE)
				{
					m_bCueDownDeckB = TRUE;
					m_procb(HERC_CUE, 127, m_dwUser);
				}
				
			}
			else
			{
				if(m_bCueDownDeckB == TRUE)
				{
					m_bCueDownDeckB = FALSE;
					m_procb(HERC_CUE, 0, m_dwUser);
				}
			}

			if(code & RightTrackPrev)
			{
				if(m_bTrackPrevDownDeckB == FALSE)
				{
					m_bTrackPrevDownDeckB = TRUE;
					m_procb(HERC_TRACKPREV, 127, m_dwUser);
				}				
			}
			else
			{
				if(m_bTrackPrevDownDeckB == TRUE)
				{
					m_bTrackPrevDownDeckB = FALSE;
					m_procb(HERC_TRACKPREV, 0, m_dwUser);
				}
			}

			if(code & RightTrackNext)
			{
				if(m_bTrackNextDownDeckB == FALSE)
				{
					m_bTrackNextDownDeckB = TRUE;
					m_procb(HERC_TRACKNEXT, 127, m_dwUser);
				}
			}
			else
			{
				if(m_bTrackNextDownDeckB == TRUE)
				{
					m_bTrackNextDownDeckB = FALSE;
					m_procb(HERC_TRACKNEXT, 0, m_dwUser);
				}
			}

			if(code & RightPitchBendPlus)
			{
				if(m_bPitchBendUpDownDeckB == FALSE)
				{
					m_bPitchBendUpDownDeckB = TRUE;
					m_procb(HERC_PITCHBEND_UP, 127, m_dwUser);
				}
			}
			else
			{
				if(m_bPitchBendUpDownDeckB == TRUE)
				{
					m_bPitchBendUpDownDeckB = FALSE;
					m_procb(HERC_PITCHBEND_UP, 0, m_dwUser);
				}
			}

			if(code & RightPitchBendMinus)
			{
				if(m_bPitchBendDownDownDeckB == FALSE)
				{
					m_bPitchBendDownDownDeckB = TRUE;
					m_procb(HERC_PITCHBEND_DOWN, 127, m_dwUser);
				}
			}
			else
			{
				if(m_bPitchBendDownDownDeckB == TRUE)
				{
					m_bPitchBendDownDownDeckB = FALSE;
					m_procb(HERC_PITCHBEND_DOWN, 0, m_dwUser);
				}
			}

			if(code & RightPreview)
			{
				if(m_bPreviewDownDeckB == FALSE)
				{
					m_bPreviewDownDeckB = TRUE;
					m_procb(HERC_PREVIEW, 127, m_dwUser);
				}
			}
			else
			{
				if(m_bPreviewDownDeckB == TRUE)
				{
					m_bPreviewDownDeckB = FALSE;
					m_procb(HERC_PREVIEW, 0, m_dwUser);
				}
			}

			if(code & RightOne)
			{
				if(m_bOneDownDeckB == FALSE)
				{
					m_bOneDownDeckB = TRUE;
					m_procb(HERC_ONE, 127, m_dwUser);
				}
			}
			else
			{
				if(m_bOneDownDeckB == TRUE)
				{
					m_bOneDownDeckB = FALSE;
					m_procb(HERC_ONE, 0, m_dwUser);
				}
			}

			if(code & RightTwo)
			{
				if(m_bTwoDownDeckB == FALSE)
				{
					m_bTwoDownDeckB = TRUE;
					m_procb(HERC_TWO, 127, m_dwUser);
				}
			}
			else
			{
				if(m_bTwoDownDeckB == TRUE)
				{
					m_bTwoDownDeckB = FALSE;
					m_procb(HERC_TWO, 0, m_dwUser);
				}
			}

			if(code & RightThree)
			{
				if(m_bThreeDownDeckB == FALSE)
				{
					m_bThreeDownDeckB = TRUE;
					m_procb(HERC_THREE, 127, m_dwUser);
				}
			}
			else
			{
				if(m_bThreeDownDeckB == TRUE)
				{
					m_bThreeDownDeckB = FALSE;
					m_procb(HERC_THREE, 0, m_dwUser);
				}
			}

			if(code & RightSelectFX)
			{
				if(m_bSelectFXDownDeckB == FALSE)
				{
					m_bSelectFXDownDeckB = TRUE;
					m_procb(HERC_SELECTFX, 127, m_dwUser);
				}
			}
			else
			{
				if(m_bSelectFXDownDeckB == TRUE)
				{
					m_bSelectFXDownDeckB = FALSE;
					m_procb(HERC_SELECTFX, 0, m_dwUser);
				}
			}

			if(code & RightMasterTempo)
			{
				if(m_bMasterTempoDownDeckB == FALSE)
				{
					m_bMasterTempoDownDeckB = TRUE;
					m_procb(HERC_MASTERTEMPO, 127, m_dwUser);
				}
			}
			else
			{
				if(m_bMasterTempoDownDeckB == TRUE)
				{
					m_bMasterTempoDownDeckB = FALSE;
					m_procb(HERC_MASTERTEMPO, 0, m_dwUser);
				}
			}

			if(code & RightAutoBeat)
			{
				if(m_bAutoBeatDownDeckB == FALSE)
				{
					m_bAutoBeatDownDeckB = TRUE;
					m_procb(HERC_AUTOBEAT, 127, m_dwUser);
				}
			}
			else
			{
				if(m_bAutoBeatDownDeckB == TRUE)
				{
					m_bAutoBeatDownDeckB = FALSE;
					m_procb(HERC_AUTOBEAT, 0, m_dwUser);
				}
			}

			if(code & RightMouseButton)
			{
				if(m_bMouseButtonDownDeckB == FALSE)
				{
					m_bMouseButtonDownDeckB = TRUE;
					m_procb(HERC_MOUSEBUTTON, 127, m_dwUser);
				}
			}
			else
			{
				if(m_bMouseButtonDownDeckB == TRUE)
				{
					m_bMouseButtonDownDeckB = FALSE;
					m_procb(HERC_MOUSEBUTTON, 0, m_dwUser);
				}
			}


				//Handle left knobs

			if(m_nLastFade != crossfade)
			{
				m_proca(HERC_CROSSFADER, crossfade, m_dwUser);
				m_procb(HERC_CROSSFADER, crossfade, m_dwUser);
				m_nLastFade = crossfade;
			}

			if(m_nLastVolume[0] != leftvolume)
			{
				m_proca(HERC_VOLUME, leftvolume, m_dwUser);
				m_nLastVolume[0] = leftvolume;
			}

			if(m_nLastJogWheel[0] != leftjogwheel)
			{
				m_proca(HERC_JOGWHEEL, leftjogwheel, m_dwUser);
				m_nLastJogWheel[0] = leftjogwheel;
			}

			if(m_nLastBass[0] != leftbass)
			{

				m_proca(HERC_BASS, leftbass, m_dwUser);
				m_nLastBass[0] = leftbass;
			}

			
			if(m_nLastMid[0] != leftmid)
			{

				m_proca(HERC_MEDIUM, leftmid, m_dwUser);
				m_nLastMid[0] = leftmid;
			}

			if(m_nLastTreble[0] != lefttreble)
			{

				m_proca(HERC_TREBLE, lefttreble, m_dwUser);
				m_nLastTreble[0] = lefttreble;
			}

			if(m_nLastPitch[0] != leftpitch)
			{

				m_proca(HERC_PITCH, leftpitch, m_dwUser);
				m_nLastPitch[0] = leftpitch;
			}






			//Handle right knobs

			if(m_nLastVolume[1] != rightvolume)
			{
				m_procb(HERC_VOLUME, rightvolume, m_dwUser);
				m_nLastVolume[1] = rightvolume;
			}

			if(m_nLastJogWheel[1] != rightjogwheel)
			{
				m_procb(HERC_JOGWHEEL, rightjogwheel, m_dwUser);
				m_nLastJogWheel[1] = rightjogwheel;
			}

			if(m_nLastBass[1] != rightbass)
			{

				m_procb(HERC_BASS, rightbass, m_dwUser);
				m_nLastBass[1] = rightbass;
			}

			
			if(m_nLastMid[1] != rightmid)
			{

				m_procb(HERC_MEDIUM, rightmid, m_dwUser);
				m_nLastMid[1] = rightmid;
			}

			if(m_nLastTreble[1] != righttreble)
			{

				m_procb(HERC_TREBLE, righttreble, m_dwUser);
				m_nLastTreble[1] = righttreble;
			}

			if(m_nLastPitch[1] != rightpitch)
			{

				m_procb(HERC_PITCH, rightpitch, m_dwUser);
				m_nLastPitch[1] = rightpitch;
			}

			
			break;
		}
	case WAIT_TIMEOUT:
		{
			Result = CancelIo(ReadHandle);
			
			CloseHandles();
			
			MyDeviceDetected = FALSE;
			break;
		}
	default:
		{
			
			CloseHandles();
			
			MyDeviceDetected = FALSE;
			break;
		}
	}
	

	
	ResetEvent(hEventObject);
	

	
}


void WriteHercules(CString cszLED, BOOL bOn, DWORD dwLED, DWORD dwDeckID)
{
	//Send a report to the device.

	DWORD	BytesWritten = 0;
	INT		Index =0;
	ULONG	Result;
	CString	strBytesWritten = "";

	//The first byte is the report number.
	int value1;
	int value2;
	int value3;
	_stscanf(cszLED.Mid(0,2), _T("%02x"), &value1);
	_stscanf(cszLED.Mid(2,2), _T("%02x"), &value2);
	_stscanf(cszLED.Mid(4,2), _T("%02x"), &value3);
	
	int nWhole = nLEDString1+nLEDString2+nLEDString3;
	int nWholePass = value1+value2+value3;

	

	BOOL bLEDState = FALSE;
	switch(dwLED)
	{
	case HERC_LED_PLAY:
		bLEDState = bLEDPlayOn[dwDeckID];
		break;
	case HERC_LED_CUE:
		bLEDState = bLEDCueOn[dwDeckID];
		break;
	case HERC_LED_AUTOBEAT:
		bLEDState = bLEDAutoBeatOn[dwDeckID];
		break;
	case HERC_LED_MONITOR:
		bLEDState = bLEDMonitorOn[dwDeckID];
		break;
	case HERC_LED_MASTERTEMPO:
		bLEDState = bLEDMasterTempoOn[dwDeckID];
		break;
	case HERC_LED_LOOPFX:
		bLEDState = bLEDLoopFXOn[dwDeckID];
		break;
	case HERC_LED_CUEFX:
		bLEDState = bLEDCueFXOn[dwDeckID];
		break;
	case HERC_LED_FX:
		bLEDState = bLEDFXOn[dwDeckID];
		break;
	}

	if(!bOn)
	{
		if(bLEDState)
		{
			nLEDString1 -= value1;
			nLEDString2 -= value2;
			nLEDString3 -= value3;	

			switch(dwLED)
			{
			case HERC_LED_PLAY:
				bLEDPlayOn[dwDeckID]=0;
				break;
			case HERC_LED_CUE:
				bLEDCueOn[dwDeckID]=0;
				break;
			case HERC_LED_AUTOBEAT:
				bLEDAutoBeatOn[dwDeckID]=0;
				break;
			case HERC_LED_MONITOR:
				bLEDMonitorOn[dwDeckID]=0;
				break;
			case HERC_LED_MASTERTEMPO:
				bLEDMasterTempoOn[dwDeckID]=0;
				break;
			case HERC_LED_LOOPFX:
				bLEDLoopFXOn[dwDeckID]=0;
				break;
			case HERC_LED_CUEFX:
				bLEDCueFXOn[dwDeckID]=0;
				break;
			case HERC_LED_FX:
				bLEDFXOn[dwDeckID]=0;
				break;
			}
		}
	}


	if(bOn)
	{
		if(!bLEDState)
		{
			nLEDString1 += value1;
			nLEDString2 += value2;
			nLEDString3 += value3;

			switch(dwLED)
			{
			case HERC_LED_PLAY:
				bLEDPlayOn[dwDeckID]=1;
				break;
			case HERC_LED_CUE:
				bLEDCueOn[dwDeckID]=1;
				break;
			case HERC_LED_AUTOBEAT:
				bLEDAutoBeatOn[dwDeckID]=1;
				break;
			case HERC_LED_MONITOR:
				bLEDMonitorOn[dwDeckID]=1;
				break;
			case HERC_LED_MASTERTEMPO:
				bLEDMasterTempoOn[dwDeckID]=1;
				break;
			case HERC_LED_LOOPFX:
				bLEDLoopFXOn[dwDeckID]=1;
				break;
			case HERC_LED_CUEFX:
				bLEDCueFXOn[dwDeckID]=1;
				break;
			case HERC_LED_FX:
				bLEDFXOn[dwDeckID]=1;
				break;
			}

		}
	}
	

	Buf[0]=1;
	Buf[1]=nLEDString1;
	Buf[2]=nLEDString2;
	Buf[3]=nLEDString3;


	if (WriteHandle != INVALID_HANDLE_VALUE)
			{
			Result = WriteFile 
			(WriteHandle, 
			Buf, 
			Capabilities.OutputReportByteLength, 
			&BytesWritten, 
			NULL);
		}



	if (!Result)
		{
		//The write attempt failed, so close the handles, display a message,
		//and set MyDeviceDetected to FALSE so the next attempt will look for the device.

		CloseHandles();
		
		MyDeviceDetected = FALSE;
		}
	else
		{
		
		}

}

BOOL WINEXPORT HERC_SetLED(DWORD dwDeckID, DWORD dwLEDCode, BOOL bOn)
{

	if(bInitialized && MyDeviceDetected)
	{
		if(dwDeckID == 0)
		{
			if(dwLEDCode == HERC_LED_FLASHPLAY)
				WriteHercules("000002", bOn, HERC_LED_FLASHPLAY, dwDeckID);
			else if(dwLEDCode == HERC_LED_PLAY)
				WriteHercules("000100", bOn, HERC_LED_PLAY, dwDeckID);
			else if(dwLEDCode == HERC_LED_CUE)
				WriteHercules("000800", bOn, HERC_LED_CUE, dwDeckID);
			else if(dwLEDCode == HERC_LED_AUTOBEAT)
				WriteHercules("001000", bOn, HERC_LED_AUTOBEAT, dwDeckID);
			else if(dwLEDCode == HERC_LED_MONITOR)
				WriteHercules("000200", bOn, HERC_LED_MONITOR, dwDeckID);
			else if(dwLEDCode == HERC_LED_MASTERTEMPO)
				WriteHercules("010000", bOn, HERC_LED_MASTERTEMPO, dwDeckID);
			else if(dwLEDCode == HERC_LED_FX)
				WriteHercules("040000", bOn, HERC_LED_FX, dwDeckID);
			else if(dwLEDCode == HERC_LED_CUEFX)
				WriteHercules("800000", bOn, HERC_LED_CUEFX, dwDeckID);
			else if(dwLEDCode == HERC_LED_LOOPFX)
				WriteHercules("004000", bOn, HERC_LED_LOOPFX, dwDeckID);

		}
		else if(dwDeckID == 1)
		{
			if(dwLEDCode == HERC_LED_FLASHPLAY)
				WriteHercules("000001", bOn, HERC_LED_FLASHPLAY, dwDeckID);
			else if(dwLEDCode == HERC_LED_PLAY)
				WriteHercules("400000", bOn, HERC_LED_PLAY, dwDeckID);
			else if(dwLEDCode == HERC_LED_CUE)
				WriteHercules("200000", bOn, HERC_LED_CUE, dwDeckID);
			else if(dwLEDCode == HERC_LED_AUTOBEAT)
				WriteHercules("002000", bOn, HERC_LED_AUTOBEAT, dwDeckID);
			else if(dwLEDCode == HERC_LED_MONITOR)
				WriteHercules("000400", bOn, HERC_LED_MONITOR, dwDeckID);
			else if(dwLEDCode == HERC_LED_MASTERTEMPO)
				WriteHercules("020000", bOn, HERC_LED_MASTERTEMPO, dwDeckID);
			else if(dwLEDCode == HERC_LED_FX)
				WriteHercules("080000", bOn, HERC_LED_FX, dwDeckID);
			else if(dwLEDCode == HERC_LED_CUEFX)
				WriteHercules("100000", bOn, HERC_LED_CUEFX, dwDeckID);
			else if(dwLEDCode == HERC_LED_LOOPFX)
				WriteHercules("008000", bOn, HERC_LED_LOOPFX, dwDeckID);
		}
		
		Sleep(15); //had to do this so that it wouldn't interfere with
				  //concurrent calls to set leds at same time. probably
				  //should use critical section of some sort, but that
				 // didnt seem to work... so for now, just sleep works :)
		return TRUE;
	}
	
	return FALSE;
}

void ReadAndWriteToDevice()
{

	if (MyDeviceDetected==FALSE)
		{
		MyDeviceDetected=FindTheHID(aProductID[0]);
		}
	

	if (MyDeviceDetected==TRUE)
		{
		
		//ReadHercules();
		//WriteHercules("000100");

		}
}


void PrepareForOverlappedTransfer()
{
	//Get a handle to the device for the overlapped ReadFiles.

	ReadHandle=CreateFile 
		(detailData->DevicePath, 
		GENERIC_READ, 
		FILE_SHARE_READ|FILE_SHARE_WRITE,
		(LPSECURITY_ATTRIBUTES)NULL, 
		OPEN_EXISTING, 
		FILE_FLAG_OVERLAPPED, 
		NULL);

	if (hEventObject == 0)
	{
		hEventObject = CreateEvent 
			(NULL, 
			TRUE, 
			TRUE, 
			"");
	

	//Set the members of the overlapped structure.

	HIDOverlapped.hEvent = hEventObject;
	HIDOverlapped.Offset = 0;
	HIDOverlapped.OffsetHigh = 0;
	}
}

bool FindTheHID(int nProductID)
{
	//Use a series of API calls to find a HID with a specified Vendor IF and Product ID.

	HIDD_ATTRIBUTES						Attributes;
	DWORD								DeviceUsage;
	SP_DEVICE_INTERFACE_DATA			devInfoData;
	bool								LastDevice = FALSE;
	int									MemberIndex = 0;
	LONG								Result;	
	CString								UsageDescription;

	Length = 0;
	detailData = NULL;
	DeviceHandle=NULL;

	/*
	API function: HidD_GetHidGuid
	Get the GUID for all system HIDs.
	Returns: the GUID in HidGuid.
	*/

	HidD_GetHidGuid(&HidGuid);	
	
	
	hDevInfo=SetupDiGetClassDevs 
		(&HidGuid, 
		NULL, 
		NULL, 
		DIGCF_PRESENT|DIGCF_INTERFACEDEVICE);
		
	devInfoData.cbSize = sizeof(devInfoData);

	MemberIndex = 0;
	LastDevice = FALSE;

	do
	{

		Result=SetupDiEnumDeviceInterfaces 
			(hDevInfo, 
			0, 
			&HidGuid, 
			MemberIndex, 
			&devInfoData);

		if (Result != 0)
		{


			Result = SetupDiGetDeviceInterfaceDetail 
				(hDevInfo, 
				&devInfoData, 
				NULL, 
				0, 
				&Length, 
				NULL);

			detailData = (PSP_DEVICE_INTERFACE_DETAIL_DATA)malloc(Length);

			detailData -> cbSize = sizeof(SP_DEVICE_INTERFACE_DETAIL_DATA);

			Result = SetupDiGetDeviceInterfaceDetail 
				(hDevInfo, 
				&devInfoData, 
				detailData, 
				Length, 
				&Required, 
				NULL);

			DeviceHandle=CreateFile 
				(detailData->DevicePath, 
				0, 
				FILE_SHARE_READ|FILE_SHARE_WRITE, 
				(LPSECURITY_ATTRIBUTES)NULL,
				OPEN_EXISTING, 
				0, 
				NULL);


			Attributes.Size = sizeof(Attributes);

			Result = HidD_GetAttributes 
				(DeviceHandle, 
				&Attributes);
			
			
			
			//Is it the desired device?

			MyDeviceDetected = FALSE;
			

			if (Attributes.VendorID == VendorID)
			{
				if (Attributes.ProductID == nProductID)
				{
					//Both the Vendor ID and Product ID match.

					MyDeviceDetected = TRUE;
					MyDevicePathName = detailData->DevicePath;
					

					//Register to receive device notifications.

					RegisterForDeviceNotifications();

					//Get the device's capablities.

					GetDeviceCapabilities();

					// Find out if the device is a system mouse or keyboard.
					
					DeviceUsage = (Capabilities.UsagePage * 256) + Capabilities.Usage;

					if (DeviceUsage == 0x102)
						{
						UsageDescription = "mouse";
						}
				
					if (DeviceUsage == 0x106)
						{
						UsageDescription = "keyboard";
						}

					if ((DeviceUsage == 0x102) | (DeviceUsage == 0x106)) 
						{
						/*DisplayData("");
						DisplayData("*************************");
						DisplayData("The device is a system " + UsageDescription + ".");
						DisplayData("Windows 2000 and Windows XP don't allow applications");
						DisplayData("to directly request Input reports from or "); 
						DisplayData("write Output reports to these devices.");
						DisplayData("*************************");
						DisplayData("");*/
						}

					// Get a handle for writing Output reports.

					WriteHandle=CreateFile 
						(detailData->DevicePath, 
						GENERIC_WRITE, 
						FILE_SHARE_READ|FILE_SHARE_WRITE, 
						(LPSECURITY_ATTRIBUTES)NULL,
						OPEN_EXISTING, 
						0, 
						NULL);

					

					// Prepare to read reports using Overlapped I/O.

					PrepareForOverlappedTransfer();

				} //if (Attributes.ProductID == ProductID)

				else
					//The Product ID doesn't match.

					CloseHandle(DeviceHandle);

			} //if (Attributes.VendorID == VendorID)

			else
				//The Vendor ID doesn't match.

				CloseHandle(DeviceHandle);

		//Free the memory used by the detailData structure (no longer needed).

		free(detailData);

		}  //if (Result != 0)

		else
			//SetupDiEnumDeviceInterfaces returned 0, so there are no more devices to check.

			LastDevice=TRUE;

		//If we haven't found the device yet, and haven't tried every available device,
		//try the next one.

		MemberIndex = MemberIndex + 1;

	} //do

	while ((LastDevice == FALSE) && (MyDeviceDetected == FALSE));

	if (MyDeviceDetected == FALSE)
	{
		//DisplayData("Device not detected");
	}
	else
	{
		//DisplayData("Device detected");
	}

	//Free the memory reserved for hDevInfo by SetupDiClassDevs.

	SetupDiDestroyDeviceInfoList(hDevInfo);
	

	return MyDeviceDetected;
}


void GetDeviceCapabilities()
{
	//Get the Capabilities structure for the device.

	PHIDP_PREPARSED_DATA	PreparsedData;

	/*
	API function: HidD_GetPreparsedData
	Returns: a pointer to a buffer containing the information about the device's capabilities.
	Requires: A handle returned by CreateFile.
	There's no need to access the buffer directly,
	but HidP_GetCaps and other API functions require a pointer to the buffer.
	*/

	HidD_GetPreparsedData 
		(DeviceHandle, 
		&PreparsedData);
	

	/*
	API function: HidP_GetCaps
	Learn the device's capabilities.
	For standard devices such as joysticks, you can find out the specific
	capabilities of the device.
	For a custom device, the software will probably know what the device is capable of,
	and the call only verifies the information.
	Requires: the pointer to the buffer returned by HidD_GetPreparsedData.
	Returns: a Capabilities structure containing the information.
	*/
	
	HidP_GetCaps 
		(PreparsedData, 
		&Capabilities);
	

	//Display the capabilities

	ValueToDisplay.Format("%s%X", "Usage Page: ", Capabilities.UsagePage);
	/*DisplayData(ValueToDisplay);
	ValueToDisplay.Format("%s%d", "Input Report Byte Length: ", Capabilities.InputReportByteLength);
	DisplayData(ValueToDisplay);
	ValueToDisplay.Format("%s%d", "Output Report Byte Length: ", Capabilities.OutputReportByteLength);
	DisplayData(ValueToDisplay);
	ValueToDisplay.Format("%s%d", "Feature Report Byte Length: ", Capabilities.FeatureReportByteLength);
	DisplayData(ValueToDisplay);
	ValueToDisplay.Format("%s%d", "Number of Link Collection Nodes: ", Capabilities.NumberLinkCollectionNodes);
	DisplayData(ValueToDisplay);
	ValueToDisplay.Format("%s%d", "Number of Input Button Caps: ", Capabilities.NumberInputButtonCaps);
	DisplayData(ValueToDisplay);
	ValueToDisplay.Format("%s%d", "Number of InputValue Caps: ", Capabilities.NumberInputValueCaps);
	DisplayData(ValueToDisplay);
	ValueToDisplay.Format("%s%d", "Number of InputData Indices: ", Capabilities.NumberInputDataIndices);
	DisplayData(ValueToDisplay);
	ValueToDisplay.Format("%s%d", "Number of Output Button Caps: ", Capabilities.NumberOutputButtonCaps);
	DisplayData(ValueToDisplay);
	ValueToDisplay.Format("%s%d", "Number of Output Value Caps: ", Capabilities.NumberOutputValueCaps);
	DisplayData(ValueToDisplay);
	ValueToDisplay.Format("%s%d", "Number of Output Data Indices: ", Capabilities.NumberOutputDataIndices);
	DisplayData(ValueToDisplay);
	ValueToDisplay.Format("%s%d", "Number of Feature Button Caps: ", Capabilities.NumberFeatureButtonCaps);
	DisplayData(ValueToDisplay);
	ValueToDisplay.Format("%s%d", "Number of Feature Value Caps: ", Capabilities.NumberFeatureValueCaps);
	DisplayData(ValueToDisplay);
	ValueToDisplay.Format("%s%d", "Number of Feature Data Indices: ", Capabilities.NumberFeatureDataIndices);
	DisplayData(ValueToDisplay);
	*/

	//No need for PreparsedData any more, so free the memory it's using.

	HidD_FreePreparsedData(PreparsedData);
	
}


	void CloseHandles()
	{
		//Close open handles.
		
		if (DeviceHandle != INVALID_HANDLE_VALUE)
		{
			CloseHandle(DeviceHandle);
		}
		
		if (ReadHandle != INVALID_HANDLE_VALUE)
		{
			CloseHandle(ReadHandle);
		}
		
		if (WriteHandle != INVALID_HANDLE_VALUE)
		{
			CloseHandle(WriteHandle);
		}
	}
	
	
	BOOL DeviceNameMatch(LPARAM lParam)
	{
		
		// Compare the device path name of a device recently attached or removed 
		// with the device path name of the device we want to communicate with.
		
		PDEV_BROADCAST_HDR lpdb = (PDEV_BROADCAST_HDR)lParam;
		
		//DisplayData("MyDevicePathName = " + MyDevicePathName);
		
		if (lpdb->dbch_devicetype == DBT_DEVTYP_DEVICEINTERFACE) 
		{
			
			PDEV_BROADCAST_DEVICEINTERFACE lpdbi = (PDEV_BROADCAST_DEVICEINTERFACE)lParam;
			
			
			CString DeviceNameString;
			
			//The dbch_devicetype parameter indicates that the event applies to a device interface.
			//So the structure in LParam is actually a DEV_BROADCAST_INTERFACE structure, 
			//which begins with a DEV_BROADCAST_HDR.
			
			//The dbcc_name parameter of DevBroadcastDeviceInterface contains the device name. 
			
			//Compare the name of the newly attached device with the name of the device 
			//the application is accessing (myDevicePathName).
			
			DeviceNameString = lpdbi->dbcc_name;
			
			//DisplayData("DeviceNameString = " + DeviceNameString);
			
			
			if ((DeviceNameString.CompareNoCase(MyDevicePathName)) == 0)
				
			{
				//The name matches.
				
				return true;
			}
			else
			{
				//It's a different device.
				
				return false;
			}
			
		}
		else
		{
			return false;
		}	
	}


//END USB HID STUFF

DWORD WINEXPORT HERC_GetVersion()
{
    return MAKEWORD(1,0);
}

DWORD WINEXPORT HERC_ErrorGetCode()
{
    return HERC_ErrorCode;
}

HWND Create_HID_Window()
{
	WNDCLASSEX wndclass;
	BOOL	   registered;

	wndclass.cbSize = sizeof(wndclass);
	wndclass.style =  CS_PARENTDC | CS_VREDRAW;
	wndclass.cbClsExtra = 0;
	wndclass.cbWndExtra = 0;
	wndclass.hInstance = 0;
	wndclass.hIcon = 0;
	wndclass.hCursor = (HICON) LoadCursor(NULL, IDC_ARROW);
	wndclass.hbrBackground = (HBRUSH) NULL;
	wndclass.lpszMenuName = NULL;
	wndclass.lpszClassName = "HID Notify Handler";
	wndclass.lpfnWndProc = WndProc;
	wndclass.hIconSm = (HICON) NULL;

	registered = RegisterClassEx(&wndclass);
	//if (!registered)
		//MessageBox(mainhwnd,"Unable to emulate a winamp window class","Error!", MB_ICONEXCLAMATION | MB_ICONWARNING);


		hidwnd = CreateWindowEx(0,
						"HID Notify Handler", "ClubDJ Pro", 
						0, 
						5, 5, 25, 25, 
						(HWND) mainhwnd, (HMENU) NULL, 0, NULL);
		
		return hidwnd;
		//if (!hidwnd)
			//MessageBox(mainhwnd, "Unable to emulate Winamp Window!", "Error!", MB_ICONEXCLAMATION | MB_ICONWARNING);
}

void Destroy_HID_Window(void)
{
	DestroyWindow(hidwnd);
	hidwnd  = 0;
	UnregisterClass("HID Notify Handler", 0);
}

LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	if (msg==WM_DEVICECHANGE)
	{
		PDEV_BROADCAST_HDR lpdb = (PDEV_BROADCAST_HDR)lParam;

		TRACE("%d\n", wParam);
	switch(wParam) 
		{
		// Find out if a device has been attached or removed.
		// If yes, see if the name matches the device path name of the device we want to access.

		case DBT_DEVICEARRIVAL:
	//		DisplayData("A device has been attached.");
			
			//AfxMessageBox("attached");
			if (DeviceNameMatch(lParam))
			{
				
				//DisplayData("My device has been attached.");
			}
		
			return TRUE; 
	
		case DBT_DEVICEREMOVECOMPLETE:
			//DisplayData("A device has been removed.");

			//AfxMessageBox("removed");
			if (DeviceNameMatch(lParam))
			{
				//DisplayData("My device has been removed.");

				// Look for the device on the next transfer attempt.
				HERC_Free();


			}
			return TRUE; 
	
		default:
			return TRUE; 
		}
		
	
	}
	return DefWindowProc(hwnd, msg, wParam, lParam);
}

HANDLE Vis_New_Thread_Init()
{
	Vis_hThread = CreateThread(0, 0, HID_New_Thread, (void*)0, 0, &dwVis_hThreadId);
	if (!Vis_hThread)
	{
		//MessageBox(mainhwnd,"Unable to create thread!","Error !!", MB_ICONEXCLAMATION | MB_ICONWARNING);
		return 0;
	}



	CloseHandle(Vis_hThread);
	return Vis_hThread;
}

DWORD WINAPI HID_New_Thread(LPVOID lpParam)
{
	MSG  message;
				
	
	BOOL msg_return_value=FALSE;			
	LPTSTR	TempString="";
	
	
	SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_NORMAL);
	
	Create_HID_Window();
	
	do 
	{
		
		msg_return_value = GetMessage(&message, NULL, 0, 0);
		if ((message.message == WM_QUIT) || (message.message == WM_CLOSE)) Vis_Enable_Rendering = 0;
		
		TranslateMessage(&message);
		DispatchMessage(&message);
		
		
	}	while (msg_return_value);
	
	
	Destroy_HID_Window();
	
	
	
	theThread		=	0;
	Vis_hThread		=	0;
	dwVis_hThreadId =	0;
	return 0;
	
}

BOOL WINEXPORT HERC_Init(DWORD dwConsoleType, HWND hwnd)
{
	mainhwnd = hwnd;
	MyDeviceDetected=FALSE;
	BOOL bFoundHerc = FALSE;

	theThread = Vis_New_Thread_Init();
	if (!theThread)
	{
		MessageBox(mainhwnd,"Cannot initialize thread!","Error!", MB_ICONEXCLAMATION | MB_ICONWARNING);
	} 
			
	
	
	if(dwConsoleType == HERC_CONSOLE_ALL)
	{
		if(!FindTheHID(aProductID[0])) //find the hercules dj console
		{
			if(!FindTheHID(aProductID[1])) //find the hercules dj console mk2
			{
				if(!FindTheHID(aProductID[2])) //find the hercules control mp3
				{
					//Couldn't find anything
				}
				else
				{
					nConsoleType = 1;
					m_dwConsoleType = HERC_CONSOLE;
				}
			}
			else
			{
				m_dwConsoleType = HERC_CONSOLE_MK2;
				nConsoleType =1;
			}
		}
		else
		{
			m_dwConsoleType = HERC_CONSOLE_MP3;
			nConsoleType = 0;
		}
	}
	else if(dwConsoleType == HERC_CONSOLE)
	{
		m_dwConsoleType = dwConsoleType;
		if(!FindTheHID(aProductID[0])) //find the hercules dj console
		{
		}
	}
	else if(dwConsoleType == HERC_CONSOLE_MK2)
	{
		m_dwConsoleType = dwConsoleType;
		if(!FindTheHID(aProductID[1])) //find the hercules dj console mk2
		{
		}
	}
	else if(dwConsoleType == HERC_CONSOLE_MP3)
	{
		m_dwConsoleType = dwConsoleType;
		if(!FindTheHID(aProductID[2])) //find the hercules dj control mp3
		{
		}
	}


	
	
	//ReadAndWriteToDevice();

	
	

	if(MyDeviceDetected)
	{
		bInitialized = TRUE;
		BOOL bFoundDevices = FALSE;
		
		m_bModeDownDeckA = FALSE;
		m_bPlayDownDeckA = FALSE;
		m_bCueDownDeckA = FALSE;
		m_bTrackPrevDownDeckA = FALSE;
		m_bTrackNextDownDeckA = FALSE;
		m_bAutoBeatDownDeckA = FALSE;
		m_bOneDownDeckA = FALSE;
		m_bTwoDownDeckA = FALSE;
		m_bThreeDownDeckA = FALSE;
		m_bPitchBendUpDownDeckA = FALSE;
		m_bPitchBendDownDownDeckA = FALSE;
		m_bPreviewDownDeckA = FALSE;
		m_bMasterTempoDownDeckA = FALSE;
		m_bSelectFXDownDeckA = FALSE;
		m_bMouseButtonDownDeckA = FALSE;
		
		m_bModeDownDeckB = FALSE;
		m_bPlayDownDeckB = FALSE;
		m_bCueDownDeckB = FALSE;
		m_bTrackPrevDownDeckB = FALSE;
		m_bTrackNextDownDeckB = FALSE;
		m_bAutoBeatDownDeckB = FALSE;
		m_bOneDownDeckB = FALSE;
		m_bTwoDownDeckB = FALSE;
		m_bThreeDownDeckB = FALSE;
		m_bPitchBendUpDownDeckB = FALSE;
		m_bPitchBendDownDownDeckB = FALSE;
		m_bPreviewDownDeckB = FALSE;
		m_bMasterTempoDownDeckB = FALSE;
		m_bSelectFXDownDeckB = FALSE;
		m_bMouseButtonDownDeckB = FALSE;

		
		
		bFoundHerc = TRUE;
    }
    else
	{
			HERC_ErrorCode = HERC_ERROR_DEVICE;
	}
	
	

    return bFoundHerc;
}

void CALLBACK ReadHercTimer(UINT uTimerID, UINT uMsg, DWORD dwUser, DWORD dw1, DWORD dw2)
{
	ReadHercules();
}


BOOL WINEXPORT HERC_Free()
{

	HERC_SetLED(0, HERC_LED_CUE, false);
	HERC_SetLED(0, HERC_LED_PLAY, false);
	HERC_SetLED(0, HERC_LED_AUTOBEAT, false);
	HERC_SetLED(0, HERC_LED_MONITOR, false);
	HERC_SetLED(0, HERC_LED_MASTERTEMPO, false);
	HERC_SetLED(0, HERC_LED_LOOPFX, false);
	HERC_SetLED(0, HERC_LED_CUEFX, false);
	HERC_SetLED(0, HERC_LED_FX, false);
	HERC_SetLED(1, HERC_LED_CUE, false);
	HERC_SetLED(1, HERC_LED_PLAY, false);
	HERC_SetLED(1, HERC_LED_AUTOBEAT, false);
	HERC_SetLED(1, HERC_LED_MONITOR, false);
	HERC_SetLED(1, HERC_LED_MASTERTEMPO, false);
	HERC_SetLED(1, HERC_LED_LOOPFX, false);
	HERC_SetLED(1, HERC_LED_CUEFX, false);
	HERC_SetLED(1, HERC_LED_FX, false);

	m_proca = NULL;
	m_procb = NULL;
	m_dwUser = NULL;

	
	for(int i=0; i<2; i++)
	{
		bLEDPlayOn[i] = 0;
		bLEDCueOn[i] = 0;
		bLEDAutoBeatOn[i] = 0;
		bLEDMonitorOn[i] = 0;
		bLEDMasterTempoOn[i] = 0;
		bLEDLoopFXOn[i] = 0;
		bLEDCueFXOn[i] = 0;
		bLEDFXOn[i] = 0;
	}

	if(MyDeviceDetected && bInitialized)
	{
		CloseHandles();
		if(hercread)
			timeKillEvent(hercread);

		bTerminated = TRUE;

	}

	MyDeviceDetected = FALSE;
	bInitialized = FALSE;

    return TRUE;
}

BOOL WINEXPORT HERC_EventCallbackSet(HERCPROC* proca, HERCPROC* procb, DWORD user)
{
	if(bInitialized)
	{
		m_proca = proca;
		m_procb = procb;
		m_dwUser = user;

		//hercread = timeSetEvent(50, 50, (LPTIMECALLBACK)&ReadHercTimer, 0, TIME_PERIODIC);
		bTerminated = FALSE;
		AfxBeginThread(WorkerThread, 0, THREAD_PRIORITY_NORMAL);
	}
	else
	{
		HERC_ErrorCode = HERC_ERROR_INIT;
		return FALSE;
	}

	return TRUE;
}